/*
 * print.c
 *
 * 
 * Author: 
 *  Richard Hult <rhult@hem.passagen.se>
 * 
 *  http://www.dtek.chalmers.se/~d4hult/oregano/ 
 * 
 * Copyright (C) 1999,2000  Richard Hult 
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the 
 * License, or (at your option) any later version. 
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <config.h>
#include <gnome.h>
//#include <libgnomeprint/gnome-printer.h>
//#include <libgnomeprint/gnome-print.h>
//#include <libgnomeprint/gnome-printer-dialog.h>
#include "schematic.h"
#include "schematic-view.h"
#include "sheet.h"
#include "print.h"
#include "print-part.h"
#include "print-wire.h"

typedef struct {
	GtkWidget *dialog;
//	GnomePrinterWidget *printer_widget;
} PrinterDialog;

//static PrinterDialog *printer_dialog_new (void);
//GnomePrinter *printer_dialog_run (SchematicView *sv);

void
print_schematic (Schematic *sm)
{
#if 0       
	OreganoPrintContext *opc;
	GSList *list;
	double affine [6];

	opc = g_new0 (OreganoPrintContext, 1);

	opc->printer = printer_dialog_run (sm);

	if (opc->printer == NULL)
		return;

	opc->ctx = gnome_print_context_new (opc->printer);

	opc->label_font = gnome_font_new_closest ("Helvetica", GNOME_FONT_MEDIUM, FALSE, 8);
	if (!opc->label_font) {
		g_warning (_("Could not create font."));
		return;
	}

	/*
	 * Turn the coordinate system upside down to match the canvas system.
	 */
	gnome_print_scale(opc->ctx, 0.50, -0.5);

	art_affine_translate (affine, 0, -2*840);
	gnome_print_concat (opc->ctx, affine);

//	for (list = sheet_get_parts (sm->sheet); list; list = list->next)
//		print_part (opc, list->data);

//	for (list = sheet_get_wires (sm->sheet); list; list = list->next)
//		print_wire (opc, list->data);

	gnome_print_showpage (opc->ctx);
	gnome_print_context_close_file (opc->ctx);
	gtk_object_unref (GTK_OBJECT (opc->ctx));
	gtk_object_unref (GTK_OBJECT (opc->printer));
	gtk_object_unref (GTK_OBJECT (opc->label_font));

	g_free (opc);
#endif
}

#if 0
static PrinterDialog *
printer_dialog_new (void)
{
	GtkWidget *dialog;
	PrinterDialog *pd;
	
	dialog = gnome_dialog_new (_("Printer Dialog"), NULL);

	pd = g_new0 (PrinterDialog, 1);
	pd->dialog = dialog;

	gnome_dialog_append_button (GNOME_DIALOG (dialog),
				    GNOME_STOCK_BUTTON_OK);
	
	gnome_dialog_append_button (GNOME_DIALOG (dialog),
				     GNOME_STOCK_BUTTON_CANCEL);
	
	gnome_dialog_set_default (GNOME_DIALOG (dialog), 0);
	
	pd->printer_widget = GNOME_PRINTER_WIDGET (gnome_printer_widget_new ());
	gtk_box_pack_start (GTK_BOX (GNOME_DIALOG (dialog)->vbox),
			    GTK_WIDGET (pd->printer_widget),
			    TRUE, TRUE, 0);
	
	return pd;
}
#endif

#if 0
GnomePrinter *
printer_dialog_run (SchematicView *sv)
{
	int                    bn;
	GnomePrinterWidget    *pw;
	GnomePrinter          *printer;
	PrinterDialog         *pd;
	
	pd = printer_dialog_new ();

	pw = pd->printer_widget;

	/* The printer menu is better, but gnome_printer_dialog does
           not expose it */
	gtk_widget_grab_focus (GTK_WIDGET(pw->r1));
	gnome_dialog_editable_enters(GNOME_DIALOG(pd->dialog), 
				     GTK_EDITABLE(pw->entry_command));
	gnome_dialog_editable_enters(GNOME_DIALOG(pd->dialog), 
				     GTK_EDITABLE(pw->entry_filename));

	gtk_window_set_modal (GTK_WINDOW (pd->dialog), TRUE);
	gnome_dialog_set_parent (GNOME_DIALOG (pd->dialog), GTK_WINDOW(sv->toplevel));
	bn = gnome_dialog_run (GNOME_DIALOG (pd->dialog));
	
	if (bn < 0)
		return NULL;
       	
	printer = NULL;

	if (bn == 0) {
		printer = gnome_printer_widget_get_printer (
			GNOME_PRINTER_WIDGET (pd->printer_widget));
	}
	
	gtk_widget_destroy (pd->dialog);

	g_free (pd);

	return printer;
}
#endif
